---
icon: IconFile
title: app.config.ts
head.title: Nuxt App Config
---

# Nuxt App Config

You can easily provide runtime app configuration using `app.config.ts` file. It can have either of `.ts`, `.js`, or `.mjs` extensions.

```ts [app.config.ts]
export default defineAppConfig({
  foo: 'bar'
})
```

::alert{type=warning}
Do not put any secret values inside `app.config` file. It is exposed to the user client bundle.
::

::ReadMore{link="/guide/features/app-config"}
